%define version 0.5.0
%define rel 1
%define CHROOTDIR /var/spool/vscan
%define BASE_LIBS glibc,libgcc,expat,libstdc++,zlib,bzip2-libs
%define ARCHIVERS tar,arc,unace,unrar,rar,zoo,unarj,arj,unzip,zip,gzip,bzip2
%define ANTIVIRS clamav,clamav-libs,avglinux,nod32lfs,kav4mailservers-linux
%define ANTISPAMS bogofilter,qsf

Summary:   sagator - antivir gateway for smtp server
Name:      sagator
Version:   %{version}
Release:   %rel%{?repo}
#Epoch:     1
Source:    http://www.salstar.sk/pub/antivir/snapshots/sagator-%{version}.tar.bz2
URL:       http://www.salstar.sk/pub/antivir/sagator/
Copyright: GPL
Packager:  Jan ONDREJ (SAL) <ondrejj@salstar.sk>
Group:     System Environment/Daemons
Requires:  python >= 2.2.2
Requires:  initscripts, postfix
#BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires:	python >= 2.2.2
BuildRequires:	initscripts

%description
This package is an interface between smtp server and antivir/spamchecker.

%package libclamav
Summary:   ClamAV native support via libclamav
Group:     Libraries
#BuildArch: i386
Requires:  %{name}

%description libclamav
This is a ClamAV native support via libclamav.

%prep
%setup -n %{name}

%build
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/var/spool/vscan/tmp/quarantine

%pre
id vscan > /dev/null 2>&1 || adduser -r -M vscan

%post
#exec &>/dev/null
if [ -x /sbin/chkconfig ]; then
  chkconfig --add sagator
fi
# Adding postfix config
if [ $1 = 2 ]; then # upgrade
  true
else
mkdir -p %{CHROOTDIR}
/usr/sbin/mkchroot.sagator --auto
cat >> /etc/postfix/main.cf << EOF
#begin: sagator
content_filter=smtp:[127.0.0.1]:27
#end: sagator
EOF
cat >> /etc/postfix/master.cf << EOF
#begin: sagator
127.0.0.1:26	inet n - n - 30 smtpd
  -o content_filter=
  -o myhostname=sagator.`hostname`
  -o local_recipient_maps=  -o relay_recipient_maps=
  -o mynetworks=127.0.0.0/8  -o mynetworks_style=host
  -o smtpd_restriction_classes=  -o smtpd_client_restrictions=
  -o smtpd_helo_restrictions=  -o smtpd_sender_restrictions=
  -o smtpd_recipient_restrictions=permit_mynetworks,reject
#end: sagator
EOF
# reload postfix
/etc/init.d/postfix reload || true
fi

%preun
#exec &>/dev/null
if [ $1 = 0 ]; then # uninstall
  [ "%{CHROOTDIR}" != "/" ] && rm -rf %{CHROOTDIR}/*
  if [ "$1" = 0 ] ; then
    if [ -x /sbin/chkconfig ]; then
      chkconfig --del sagator
    fi
  fi
  # Removing postfix config
  mv /etc/postfix/main.cf /etc/postfix/main.cf.tmp
  sed '/^#begin: sagator/,/^#end: sagator/d' \
    < /etc/postfix/main.cf.tmp > /etc/postfix/main.cf
  mv /etc/postfix/master.cf /etc/postfix/master.cf.tmp
  sed '/^#begin: sagator/,/^#end: sagator/d' \
    < /etc/postfix/master.cf.tmp > /etc/postfix/master.cf
  /etc/init.d/postfix reload || true
fi

%triggerin -- %{BASE_LIBS},%{ARCHIVERS},%{ANTIVIRS},%{ANTISPAMS}
echo "Updating sagator's chroot..."
/usr/sbin/mkchroot.sagator --auto || true

#%triggerpostun -- %{BASE_LIBS},%{ARCHIVERS},%{ANTIVIRS},%{ANTISPAMS}
#echo "Updating sagator's chroot..."
#/usr/sbin/mkchroot.sagator --auto || true

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sagator.conf
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sysconfig/sagator
%config %{_sysconfdir}/logrotate.d/sagator
%{_sysconfdir}/rc.d/init.d/*
%config(noreplace) %verify(not md5 size mtime) %attr(755,root,root) %{_sysconfdir}/cron.daily/sagator
%doc README TODO COPYING README.scanners ChangeLog
%doc scripts/mrtg* *-template
%doc test
/usr/bin/*
/usr/sbin/*
%dir /usr/lib/sagator
/usr/lib/sagator/*.py*
%dir /usr/lib/sagator/av
/usr/lib/sagator/av/*.py*
%dir /usr/lib/sagator/as
/usr/lib/sagator/as/*.py*
%dir /usr/lib/sagator/interscan
/usr/lib/sagator/interscan/*.py*
%dir /var/spool/vscan
%attr(1777,vscan,vscan) %dir /var/spool/vscan/tmp
%attr(0770,vscan,vscan) %dir /var/spool/vscan/tmp/quarantine

%files libclamav
%defattr(-,root,root)
/usr/lib/sagator/libclamav.so

%changelog
* Mon May 31 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- cron script is now as configuration script (not replaced)

* Thu Apr 29 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- added triggers

* Tue Apr 13 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- /var/spool/vscam/tmp permission fix

* Wed Feb  4 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- postfix requirement added
- fixed scriptlet fail when postfix is not started
- testing programs added to documentation

* Wed Jan 28 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- configs are not replaced

* Mon Jan 19 2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- added sysconfig file
- added logrotate files
- config moved into /etc and symlink into /usr/lib/sagator

* Fri Oct 31 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- added mrtg.cfg and index.html
- making of chroot removed on upgrading

* Thu Sep 18 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- postfix is not reloaded, when sagator is upgrading

* Tue Jun 10 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
- first release
